<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Enum Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284027"></a>Enum Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Juha</span> <span class="surname">Heinanen</span></h3><code class="email">&lt;<a class="email" href="mailto:jh@song.fi">jh@song.fi</a>&gt;</code></div><div class="author"><h3 class="author"><span class="firstname">Otmar</span> <span class="surname">Lendl</span></h3><code class="email">&lt;<a class="email" href="mailto:lendl@nic.at">lendl@nic.at</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2002, 2003 Juha Heinanen</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2009-07-21 09:45:05 +0200 (Tue, 21 Jul 2009) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id268059">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#sec-overview">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id249632">1.2. Dependencies</a></span></dt><dt><span class="section"><a href="#id248903">1.3. Exported Parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id248908">1.3.1. <code class="varname">domain_suffix</code> (string)</a></span></dt><dt><span class="section"><a href="#id248944">1.3.2. <code class="varname">tel_uri_params</code> (string)</a></span></dt><dt><span class="section"><a href="#id293514">1.3.3. <code class="varname">i_enum_suffix</code> (string)</a></span></dt><dt><span class="section"><a href="#id293545">1.3.4. <code class="varname">isn_suffix</code> (string)</a></span></dt><dt><span class="section"><a href="#id293576">1.3.5. <code class="varname">branchlabel</code> (string)</a></span></dt><dt><span class="section"><a href="#id293608">1.3.6. <code class="varname">bl_algorithm</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293685">1.4. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293691">1.4.1. 
		<code class="function">enum_query(["suffix"[,"service"]])</code>
		</a></span></dt><dt><span class="section"><a href="#id293865">1.4.2. 
		<code class="function">enum_pv_query("pvar"[,"suffix"[,"service"]])</code>
		</a></span></dt><dt><span class="section"><a href="#id293943">1.4.3. 
                <code class="function">i_enum_query(["suffix"[,"service"]])</code>
                </a></span></dt><dt><span class="section"><a href="#id293966">1.4.4. 
		<code class="function">isn_query(["suffix"[,"service"]])</code>
		</a></span></dt><dt><span class="section"><a href="#id294035">1.4.5. <code class="function">is_from_user_enum()</code></a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248931">Setting domain_suffix module parameter</a></dt><dt>1.2. <a href="#id293502">Setting tel_uri_params module parameter</a></dt><dt>1.3. <a href="#id293533">Setting i_enum_suffix module parameter</a></dt><dt>1.4. <a href="#id293564">Setting isn_suffix module parameter</a></dt><dt>1.5. <a href="#id293595">Setting branchlabel module parameter</a></dt><dt>1.6. <a href="#id293630">Zone file example</a></dt><dt>1.7. <a href="#id293650">Zone file example</a></dt><dt>1.8. <a href="#id293672">Setting the bl_algorithm module parameter</a></dt><dt>1.9. <a href="#id293839"><code class="function">enum_query</code> usage</a></dt><dt>1.10. <a href="#id293921"><code class="function">enum_pv_query</code> usage</a></dt><dt>1.11. <a href="#id294016"><code class="function">isn_query</code> usage</a></dt><dt>1.12. <a href="#id294053"><code class="function">is_from_user_enum</code> usage</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id268059"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="sec-overview"></a>1.1. Overview</h2></div></div></div><p>
		Enum module implements [i_]enum_query functions that make an enum query 
		based on the user part of the current Request-URI. These functions
		assume that the user part consists of an international phone number 
		of the form +decimal-digits, where the number of digits is at
		least 2 and at most 15. Out of this number 
		<code class="function">enum_query</code> forms a domain name, 
		where the digits are in reverse order and separated by dots followed by 
		domain suffix that by default is &#8220;<span class="quote">e164.arpa.</span>&#8221;. For example, 
		if the user part is +35831234567, the domain
		name will be &#8220;<span class="quote">7.6.5.4.3.2.1.3.8.5.3.e164.arpa.</span>&#8221;.
		<code class="function">i_enum_query</code> operates in a similar
		fashion. The only difference is that it adds a label (default "i")
		to branch off from the default, user-ENUM tree to an infrastructure ENUM tree.
	</p><p>
		After forming the domain name, 
		<code class="function">enum_query</code> queries
		DNS for its NAPTR records. From the possible response 
		<code class="function">enum_query</code> chooses those records, 
		whose flags field has string value "u", and whose services field has 
		string value "e2u+[service:]sip" or 
		"e2u+type[:subtype][+type[:subtype]...]" (case is ignored in both 
		cases), and whose regexp field is of the form !pattern!replacement!.
	</p><p>
		Then <code class="function">enum_query</code> sorts the chosen 
		NAPTR records based on their &lt;order, preference&gt;.  After sorting, 
		<code class="function">enum_query</code> replaces the current 
		Request URI by applying regexp of the most preferred NAPTR record its 
		user part and appends to the request new branches by applying regexp of 
		each remaining NAPTR record to the user part of the
		current Request URI. If a new URI is a tel URI, 
		<code class="function">enum_query</code> appends to it as tel 
		URI parameters the value of tel_uri_params module parameter. Finally, 
		<code class="function">enum_query</code> associates a q value 
		with each new URI based on the &lt;order, preference&gt; of the 
		corresponding NAPTR record.
	</p><p>
		When using <code class="function">enum_query</code> without any 
		parameters, it searches for NAPTRs with service type "e2u+sip" in the 
		default enum tree. When using 
		<code class="function">enum_query</code> with a single parameter, 
		this parameter will be used as enum tree. When using 
		<code class="function">enum_query</code> 
		with two parameters, the functionality depends on the first letter in 
		the second parameter. When the first letter is not a '+' sign, the 
		second parameter will be used to search for NAPTRs with service type 
		"e2u+parameter:sip". When the second parameter starts with a '+' sign, 
		the ENUM lookup also supports compound NAPTRs 
		(e.g. "e2u+voice:sip+video:sip") and searching for multiple service 
		types within one lookup. Multiple service types must be separeted 
		by a '+' sign.
	</p><p>
		Most of the time you want to route based on the RURI.  On rare occasions
		you may wish to route based on something else. The function
		<code class="function">enum_pv_query</code> mimics the behavior
		of the <code class="function">enum_query</code> function except the
		E.164 number in its pseudo variable argument is used for the enum lookup instead of the user
		part of the RURI.  Obviously the user part of the RURI is still used in the
		NAPTR regexp.
	</p><p>
		Enum query returns 1 if the current Request URI was replaced 
		and -1 if not.
	</p><p>
		In addition to standard ENUM, support for ISN (ITAD Subscriber
		Numbers) is provided as well. To allow ISN lookups to resolve,
		a different formatting algorithm is expected by the DNS server.
		Whereas a ENUM NAPTR record expects a DNS query of the form
		9.8.7.6.5.4.3.2.1.suffix, ISN method expects a DNS query of
		the form 6.5.1212.suffix. That is, a valid ISN number includes
		a prefix of '56' in the example. The rest of the number is a
		ITAD (Internet Telephony Administrative Domain) as defined
		in RFCs 3872 and 2871, and as allocated by the IANA in
		http://www.iana.org/assignments/trip-parameters. The ITAD is
		left intact and not refersed as ENUM requires. To learn more
		about ISN please refer to documents at www.freenum.org.
	</p><p>
		To complete a ISN lookup on the user part of the Request-URI,
		isn_query() is used instead of enum_query().
	</p><p>
		Enum module also implements is_from_user_enum function.
		This function does an enum lookup on the from user and
		returns true if found, false otherwise.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249632"></a>1.2. Dependencies</h2></div></div></div><p>
		The module depends on the following modules (in the other words the 
		listed modules must be loaded before this module):
		</p><div class="itemizedlist"><ul type="disc"><li><p>No dependencies.</p></li></ul></div><p>
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248903"></a>1.3. Exported Parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248908"></a>1.3.1. <code class="varname">domain_suffix</code> (string)</h3></div></div></div><p>
		The domain suffix to be added to the domain name obtained from
		the digits of an <acronym class="acronym">E164</acronym> number. Can be overridden 
		by a parameter to enum_query.
		</p><p>
		Default value is &#8220;<span class="quote">e164.arpa.</span>&#8221;
		</p><div class="example"><a name="id248931"></a><p class="title"><b>Example 1.1. Setting domain_suffix module parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("enum", "domain_suffix", "e1234.arpa.")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248944"></a>1.3.2. <code class="varname">tel_uri_params</code> (string)</h3></div></div></div><p>
		A string whose contents is appended to each new tel URI in the 
		request as tel URI parameters.
		</p><div class="note" style="margin-left: 0.5in; margin-right: 0.5in;"><h3 class="title">Note</h3><p>
			Currently OpenSIPS does not support tel URIs. This means that at present
			tel_uri_params is appended as URI parameters to every URI.
		</p></div><p>
		Default value is &#8220;<span class="quote"></span>&#8221;
		</p><div class="example"><a name="id293502"></a><p class="title"><b>Example 1.2. Setting tel_uri_params module parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("enum", "tel_uri_params", ";npdi")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293514"></a>1.3.3. <code class="varname">i_enum_suffix</code> (string)</h3></div></div></div><p>
                The domain suffix to be used for i_enum_query() lookups.
                Can be overridden by a parameter to i_enum_query.
                </p><p>
                Default value is &#8220;<span class="quote">e164.arpa.</span>&#8221;
                </p><div class="example"><a name="id293533"></a><p class="title"><b>Example 1.3. Setting i_enum_suffix module parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("enum", "i_enum_suffix", "e1234.arpa.")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293545"></a>1.3.4. <code class="varname">isn_suffix</code> (string)</h3></div></div></div><p>
                The domain suffix to be used for isn_query() lookups. Can
                be overridden by a parameter to isn_query.
                </p><p>
                Default value is &#8220;<span class="quote">freenum.org.</span>&#8221;
                </p><div class="example"><a name="id293564"></a><p class="title"><b>Example 1.4. Setting isn_suffix module parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("enum", "isn_suffix", "freenum.org.")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293576"></a>1.3.5. <code class="varname">branchlabel</code> (string)</h3></div></div></div><p>
                This parameter determines which label i_enum_query() will use
                to branch off to the infrastructure ENUM tree.
                </p><p>
                Default value is &#8220;<span class="quote">"i"</span>&#8221;
                </p><div class="example"><a name="id293595"></a><p class="title"><b>Example 1.5. Setting branchlabel module parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("enum", "branchlabel", "i")
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293608"></a>1.3.6. <code class="varname">bl_algorithm</code> (string)</h3></div></div></div><p>
                This parameter determines which algorithm i_enum_query() will use
                to select the position in the DNS tree where the infrastructure tree
                branches off the user ENUM tree.
                </p><p>
                If set to "cc", i_enum_query() will always inserts the
                label at the country-code level.
                Examples: i.1.e164.arpa, i.3.4.e164.arpa, i.2.5.3.e164.arpa
                </p><p>
                If set to "txt", i_enum_query() will look for a TXT record at
                [branchlabel].[reverse-country-code].[i_enum_suffix] to indicate after how many digits the
                label should in inserted.
                </p><div class="example"><a name="id293630"></a><p class="title"><b>Example 1.6. Zone file example</b></p><div class="example-contents"><pre class="programlisting">
i.1.e164.arpa.                     IN TXT   "4"
9.9.9.8.7.6.5.i.4.3.2.1.e164.arpa. IN NAPTR "NAPTR content for  +1 234 5678 999"
</pre></div></div><p><br class="example-break">
                </p><p>
                If set to "ebl", i_enum_query() will look for an EBL (ENUM Branch Label) record at
                [branchlabel].[reverse-country-code].[i_enum_suffix]. See http://www.ietf.org/internet-drafts/draft-lendl-enum-branch-location-record-00.txt for a description of that record and the
                meaning of the fields. The RR type for the EBL has not been allocated yet.
                This version of the code uses 65300. See resolve.h.
                </p><div class="example"><a name="id293650"></a><p class="title"><b>Example 1.7. Zone file example</b></p><div class="example-contents"><pre class="programlisting">
i.1.e164.arpa.     TYPE65300  \# 14 (
                              04    ; position
                              01 69 ; separator
                              04 65 31 36 34 04 61 72 70 61 00 ; e164.arpa
;                               )
9.9.9.8.7.6.5.i.4.3.2.1.e164.arpa. IN NAPTR "NAPTR content for  +1 234 5678 999"
</pre></div></div><p><br class="example-break">
                </p><p>
                Default value is &#8220;<span class="quote">cc</span>&#8221;
                </p><div class="example"><a name="id293672"></a><p class="title"><b>Example 1.8. Setting the bl_algorithm module parameter</b></p><div class="example-contents"><pre class="programlisting">
modparam("enum", "bl_algorithm", "txt")
</pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293685"></a>1.4. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293691"></a>1.4.1. 
		<code class="function">enum_query(["suffix"[,"service"]])</code>
		</h3></div></div></div><p>
		The function performs an enum query and rewrites the Request-URI with 
		the result of the query. See <a class="xref" href="#sec-overview" title="1.1. Overview">Section 1.1, &#8220;Overview&#8221;</a> for more 
		information.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>suffix</em></span> - Suffix to be appended to the 
			domain name.
			</p></li><li><p><span class="emphasis"><em>service</em></span> - Service string to be used in 
			the service field.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293839"></a><p class="title"><b>Example 1.9. <code class="function">enum_query</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# search for "e2u+sip" in freenum.org 
enum_query("freenum.org.");
...
# search for "e2u+sip" in default tree (configured as parameter)
enum_query();
...
# search for "e2u+voice:sip" in e164.arpa
enum_query("e164.arpa.","voice");
...
# search for service type "sip" or "voice:sip" or "video:sip"
# note the '+' sign in front of the second parameter
enum_query("e164.arpa.","+sip+voice:sip+video:sip");
...
# quering for service sip and voice:sip
enum_query("e164.arpa.");
enum_query("e164.arpa.","voice");
# or use instead
enum_query("e164.arpa.","+sip+voice:sip");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293865"></a>1.4.2. 
		<code class="function">enum_pv_query("pvar"[,"suffix"[,"service"]])</code>
		</h3></div></div></div><p>
		The function performs an enum query on E.164 number stored
		in its pseudo variable argument and rewrites the Request-URI with 
		the result of the query. See <a class="xref" href="#sec-overview" title="1.1. Overview">Section 1.1, &#8220;Overview&#8221;</a> for more 
		information.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>pvar</em></span> - Pseudo
		variable that holds an E.164 number on which enum
		query is performed.
			</p></li><li><p><span class="emphasis"><em>suffix</em></span> - Suffix to be appended to the 
			domain name.
			</p></li><li><p><span class="emphasis"><em>service</em></span> - Service string to be used in 
			the service field.
			</p></li></ul></div><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id293921"></a><p class="title"><b>Example 1.10. <code class="function">enum_pv_query</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# search for "e2u+sip" in freenum.org 
enum_pv_query("$avp(100)", "freenum.org.");
...
# search for "e2u+sip" in default tree (configured as parameter)
enum_pv_query("$fU");
...
# search for "e2u+voice:sip" in e164.arpa
enum_pv_query("$avp(100)","e164.arpa.","voice");
...
# search for service type "sip" or "voice:sip" or "video:sip"
# note the '+' sign in front of the second parameter
enum_pv_query("$fU","e164.arpa.","+sip+voice:sip+video:sip");
...
# quering for service sip and voice:sip
enum_pv_query("$avp(100)","e164.arpa.");
enum_pv_query("$avp(100)","e164.arpa.","voice");
# or use instead
enum_pv_query("$avp(100)","e164.arpa.","+sip+voice:sip");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293943"></a>1.4.3. 
                <code class="function">i_enum_query(["suffix"[,"service"]])</code>
                </h3></div></div></div><p>
                The function performs an enum query and rewrites the Request-URI with
                the result of the query. This the Infrastructure-ENUM version of enum_query().
                The only difference to enum_query() is in the calculation of the
                FQDN where NAPTR records are looked for.
                </p><p>
                See ftp://ftp.rfc-editor.org/in-notes/internet-drafts/draft-haberler-carrier-enum-01.txt
                for the rationale behind this function.
                </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293966"></a>1.4.4. 
		<code class="function">isn_query(["suffix"[,"service"]])</code>
		</h3></div></div></div><p>
		The function performs a ISN query and rewrites the Request-URI with 
		the result of the query. See <a class="xref" href="#sec-overview" title="1.1. Overview">Section 1.1, &#8220;Overview&#8221;</a> for more 
		information.
		</p><p>Meaning of the parameters is as follows:</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>suffix</em></span> - Suffix to be appended to the 
			domain name.
			</p></li><li><p><span class="emphasis"><em>service</em></span> - Service string to be used in 
			the service field.
			</p></li></ul></div><p>
			This function can be used from REQUEST_ROUTE.
		</p><p>
			See ftp://www.ietf.org/rfc/rfc3872.txt and
			ftp://www.ietf.org/rfc/rfc2871.txt for information
			regarding the ITAD part of the ISN string.
		</p><div class="example"><a name="id294016"></a><p class="title"><b>Example 1.11. <code class="function">isn_query</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
# search for "e2u+sip" in freenum.org 
isn_query("freenum.org.");
...
# search for "e2u+sip" in default tree (configured as parameter)
isn_query();
...
# search for "e2u+voice:sip" in freenum.org
isn_query("freenum.org.","voice");
...
</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id294035"></a>1.4.5. <code class="function">is_from_user_enum()</code></h3></div></div></div><p>
		Checks if the user part of from <abbr class="abbrev">URI</abbr>
		is found in an enum lookup.
		Returns 1 if yes and -1 if not.
		</p><p>
		This function can be used from REQUEST_ROUTE.
		</p><div class="example"><a name="id294053"></a><p class="title"><b>Example 1.12. <code class="function">is_from_user_enum</code> usage</b></p><div class="example-contents"><pre class="programlisting">
...
if (is_from_user_enum()) {
	....
};
...
</pre></div></div><br class="example-break"></div></div></div></div></body></html>
