<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>JSON Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id249237"></a>JSON Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Andrei</span> <span class="surname">Dragus</span></h3><div class="affiliation"><span class="orgname">Voice Sistem SRL<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Andrei</span> <span class="surname">Dragus</span></h3></div></div></div><div><p class="copyright">Copyright © 2009 Voice Sistem SRL</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 8740 $</td><td align="left">$Date: 2012-02-22 18:29:43 +0100 (Wed, 22 Feb 2012) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id271626">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248476">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248006">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id248012">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id248020">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id284069">1.3. Exported Parameters</a></span></dt><dt><span class="section"><a href="#id284079">1.4. Exported Variables</a></span></dt><dd><dl><dt><span class="section"><a href="#id249549">1.4.1. Variable lifetime </a></span></dt><dt><span class="section"><a href="#id249561">1.4.2. Accessing the $json(id) variable </a></span></dt><dt><span class="section"><a href="#id248868">1.4.3.  Returned values from $json(id) </a></span></dt><dt><span class="section"><a href="#id248892">1.4.4.  Operators for the $json(id) variable </a></span></dt></dl></dd><dt><span class="section"><a href="#id293481">1.5. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293486">1.5.1. 
			<code class="function">
				json_link("$json(dest_id)", "$json(source_id)")
				</code>
			</a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248835">Accessing the $json variable </a></dt><dt>1.2. <a href="#id248853">Iterating through an array using variables </a></dt><dt>1.3. <a href="#id293395">Appending integers to arrays</a></dt><dt>1.4. <a href="#id293407">Deleting the last element in an array</a></dt><dt>1.5. <a href="#id293418">Adding a string value to a json object</a></dt><dt>1.6. <a href="#id293441">Initializing an array</a></dt><dt>1.7. <a href="#id293453">Setting a boolean or null value </a></dt><dt>1.8. <a href="#id293465">Adding a json to another json </a></dt><dt>1.9. <a href="#id293522">Creating a reference </a></dt><dt>1.10. <a href="#id293543">[LOGICAL ERROR] Creating a  circular reference  </a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id271626"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248476"></a>1.1. Overview</h2></div></div></div><p> This module introduces a new type of variable that provides both
	serialization and de-serialization from JSON format.
	</p><p>
	The variable provides ways to access objects and arrays to add,replace
	or delete values from the script.
	</p><p>
	The correct approach is to consider a json object as a hashtable
	( you can put (key;value) pairs, and you can delete and get
	 values by key) and a json array as an array ( you can append,
	 delete and replace values).
	</p><p>
	Since the JSON format can have objects inside other objects
	you can have multiple nested hashtables or arrays and you can
	access these using paths.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248006"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248012"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		This module does not depend on other modules.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248020"></a>1.2.2. External Libraries or Applications</h3></div></div></div><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>libjson</em></span>
				The libjson library can be downloaded from:
				http://oss.metaparadigm.com/json-c/
			</p></li></ul></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284069"></a>1.3. Exported Parameters</h2></div></div></div><p>
		The module does not export any parameters.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id284079"></a>1.4. Exported Variables</h2></div></div></div><p>
		This module exports the $json(id) variable.
	</p><p>
		The json variable provides methods to access fields
		in json objects and to access indexes in json arrays.
	</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249549"></a>1.4.1. Variable lifetime </h3></div></div></div><p>
			The json variables will be available to the
			process that created them from the moment they were
			initialized. They will not reset per message or per
			transaction. If you want to use the on a per message
			basis you should initialize them each time.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249561"></a>1.4.2. Accessing the $json(id) variable </h3></div></div></div><p>
			The grammar that describes the id is:
		</p><p>
			id = name(identifier)*
		</p><p>
			identifier = key | index
		</p><p>
			key = /string | /$var
		</p><p>
			index = [integer] | [$var] | []
		</p><p>
			The "[]" index represents appending to the array.
			It should only be used when trying to set a value and
			not when trying to get one.
		</p><p>
			Negative indexes can be used to access an array starting
			from the end. So "[-1]" signifies the last element.
		</p><p>
			IMPORTANT: The id strictly complies to this grammar.
			You should be careful when using spaces because they will
			NOT be ignored. This was done to allow keys that contain
			spaces.
		</p><p>
			Variables can be used as indexes or keys. Variables
			that will be used as indexes must contain integer values.
			Variables that will be used as keys should contain
			string values.


		</p><p>
			Trying to get a value from a non-existing path
			(key or value) will return the NULL value and notice
			messages will be placed in the log describing the value
			of the json and the path used.
		</p><p>
			Trying to replace or insert a value in a
			non-existing path will cause an error in setting the value
			and notice messages will be printed in the log
			describing the value of the json and the path used
		</p><div class="example"><a name="id248835"></a><p class="title"><b>Example 1.1. Accessing the $json variable </b></p><div class="example-contents"><pre class="programlisting">
...
$json(obj1/key) = "value"; #replace or insert the (key,value)
			   #pair into the json object;
			   
$json(matrix1[1][2]) = 1;  #replace the element at index 2 in the element
			   #at index 1 in an array

xlog("$json(name/key1[0][-1]/key2)"); # a more complex example

...
		</pre></div></div><br class="example-break"><div class="example"><a name="id248853"></a><p class="title"><b>Example 1.2. Iterating through an array using variables </b></p><div class="example-contents"><pre class="programlisting">
...

$json(ar1) := "[1,2,3,4]";

$var(i) = 0;

while( $json(ar1[$var(i)]) )
{

	#print each value
	xlog("Found:[$json(ar1[$var(i)])]\n");

	#increment each value
	$json(ar1[$var(i)])  = $json(ar1[$var(i)]) + 1 ;

	$var(i) = $var(i) + 1;

}


...
		</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248868"></a>1.4.3.  Returned values from $json(id) </h3></div></div></div><p>
			If the value specified by the id is an integer
			it will be returned as an integer value.
		</p><p>
			If the value specified by the id is a string it will
			be returned as a string.
		</p><p>
			If the value specified by the id is any other
			type of json ( null, boolean, object, array )
			the serialized version of the object will be returned
			as a string value. Using this and the ":="
			operator you can duplicate json objects and put them
			in other json objects ( for string or integer you may
			use the "=" operator).
		</p><p>
			If the id does not exist a NULL value will be returned.
			
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248892"></a>1.4.4.  Operators for the $json(id) variable </h3></div></div></div><p>
			There are 2 operators available for this variable.
		</p><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id248901"></a>1.4.4.1.  The "=" operator </h4></div></div></div><p>
				This will cause the value to be taken
				as is and be added to the json object
				( e.g. string value or integer	value ).
			</p><p>
				Setting a value to NULL will cause it to be
				deleted.
			</p><div class="example"><a name="id293395"></a><p class="title"><b>Example 1.3. Appending integers to arrays</b></p><div class="example-contents"><pre class="programlisting">
...
$json(array1[]) = 1;
...
			</pre></div></div><br class="example-break"><div class="example"><a name="id293407"></a><p class="title"><b>Example 1.4. Deleting the last element in an array</b></p><div class="example-contents"><pre class="programlisting">
...
$json(array1[-1]) = NULL;
...
			</pre></div></div><br class="example-break"><div class="example"><a name="id293418"></a><p class="title"><b>Example 1.5. Adding a string value to a json object</b></p><div class="example-contents"><pre class="programlisting">
...
$json(object1/some_key) = "some_value";
...
			</pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h4 class="title"><a name="id293431"></a>1.4.4.2.  The ":=" operator </h4></div></div></div><p>
				This will cause the value to be taken
				and interpreted as a json object
				( e.g. this operator should be used to parse
				 json inputs ).
			</p><div class="example"><a name="id293441"></a><p class="title"><b>Example 1.6. Initializing an array</b></p><div class="example-contents"><pre class="programlisting">
...
$json(array1) := "[]";
...
			</pre></div></div><br class="example-break"><div class="example"><a name="id293453"></a><p class="title"><b>Example 1.7. Setting a boolean or null value </b></p><div class="example-contents"><pre class="programlisting">
...
$json(array1[]) := "null";
$json(array1[]) := "true";
$json(array1[]) := "false";
...
			</pre></div></div><br class="example-break"><div class="example"><a name="id293465"></a><p class="title"><b>Example 1.8. Adding a json to another json </b></p><div class="example-contents"><pre class="programlisting">
...

$json(array) := "[1,2,3]";
$json(object) := "{}";
$json(object/array) := $json(array) ;

...
			</pre></div></div><br class="example-break"></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293481"></a>1.5. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293486"></a>1.5.1. 
			<code class="function">
				json_link("$json(dest_id)", "$json(source_id)")
				</code>
			</h3></div></div></div><p>
			This function can be used to link json objects together.
			This will work simillar to setting a value to an object,
			the only difference is that the second object is not
			copied, only a reference is created.
			</p><p>
			Changes to any of the objects will be visible in both of
			them.
			</p><p>
			You can use this method either to create references
			so each time you access the field you don't
			have to go through the full path
			(for speed efficiency and shorter code), or
			if you have an object that must be added to many
			other objects and you don't want to copy it each
			time (space and speed efficiency).

			</p><p>
			You can think of this object exactly as a reference
			in an object-oriented language. Modifying fields
			referenced by the variable will cause modifications
			in all the objects, BUT modifying the variable itsef
			will not cause any changes to other objects.
			</p><p>
			WARNING: You should be carefull when using references.
			If you accidentally create a circular reference and try
			to get the value from the object you will crash OPENSIPS.
			</p><div class="example"><a name="id293522"></a><p class="title"><b>Example 1.9. Creating a reference </b></p><div class="example-contents"><pre class="programlisting">
...

$json(b) := "[{},{},{}]";

json_link("$json(stub)","$json(b[0])");

$json(stub/ana) = "are"; #add to the stub
$json(stub/ar) := "[]";
$json(stub/ar[]) = 1;
$json(stub/ar[]) = 2;
$json(stub/ar[]) = 3;

$json(b[0]/ar[0]) = NULL; # delete from the original object

xlog("\nTest link :\n$json(stub)\n$json(b)\n\n");

/*Output:

Test link :
{ "ana": "are", "ar": [ 2, 3 ] }
[ { "ana": "are", "ar": [ 2, 3 ] }, { }, { } ]

*/

$json(stub) = NULL; #delete the stub, no change will happen to the source


xlog("\nTest link :\n$json(stub)\n$json(b)\n\n");

/* Output:

Test link :
&lt;null&gt;
[ { "ana": "are", "ar": [ 2, 3 ] }, { }, { } ]

*/





...
			</pre></div></div><br class="example-break"><div class="example"><a name="id293543"></a><p class="title"><b>Example 1.10. [LOGICAL ERROR] Creating a  circular reference  </b></p><div class="example-contents"><pre class="programlisting">
...

$json(b) := "[1]";

/* NEVER do this, it is meant only to show where problems might occur  */
json_link("$json(b[0])","$json(b)"); # replace 1 with a reference to b

xlog("\nTest link :\n$json(stub)\n$json(b)\n\n");

/* this will cause OPENSIPS to crash because it will continuously try
 to get b, then b[0], then b ... */


...
			</pre></div></div><br class="example-break"></div></div></div></div></body></html>
