<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Mediaproxy Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>Mediaproxy Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Dan</span> <span class="surname">Pascu</span></h3><code class="email">&lt;<a class="email" href="mailto:dan@ag-projects.com">dan@ag-projects.com</a>&gt;</code></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Dan</span> <span class="surname">Pascu</span></h3><code class="email">&lt;<a class="email" href="mailto:dan@ag-projects.com">dan@ag-projects.com</a>&gt;</code></div></div></div><div><p class="copyright">Copyright © 2004 Dan Pascu</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2009-07-21 09:45:05 +0200 (Tue, 21 Jul 2009) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id282001">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id270469">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id274256">1.2. Principle of operation</a></span></dt><dt><span class="section"><a href="#id276604">1.3. Features</a></span></dt><dt><span class="section"><a href="#id249300">1.4. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249582">1.4.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249607">1.4.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id249632">1.5. Exported parameters</a></span></dt><dd><dl><dt><span class="section"><a href="#id249638">1.5.1. <code class="varname">disable</code> (int)</a></span></dt><dt><span class="section"><a href="#id248414">1.5.2. <code class="varname">mediaproxy_socket</code> (string)</a></span></dt><dt><span class="section"><a href="#id248453">1.5.3. <code class="varname">mediaproxy_timeout</code> (int)</a></span></dt><dt><span class="section"><a href="#id293433">1.5.4. <code class="varname">signaling_ip_avp</code> (string)</a></span></dt><dt><span class="section"><a href="#id248335">1.5.5. <code class="varname">media_relay_avp</code> (string)</a></span></dt><dt><span class="section"><a href="#id293588">1.5.6. <code class="varname">ice_candidate</code> (string)</a></span></dt><dt><span class="section"><a href="#id293629">1.5.7. <code class="varname">ice_candidate_avp</code> (string)</a></span></dt></dl></dd><dt><span class="section"><a href="#id293671">1.6. Exported Functions</a></span></dt><dd><dl><dt><span class="section"><a href="#id293676">1.6.1. <code class="function">engage_media_proxy()</code></a></span></dt><dt><span class="section"><a href="#id293729">1.6.2. <code class="function">use_media_proxy()</code></a></span></dt><dt><span class="section"><a href="#id293796">1.6.3. <code class="function">end_media_session()</code></a></span></dt></dl></dd></dl></dd></dl></div><div class="list-of-examples"><p><b>List of Examples</b></p><dl><dt>1.1. <a href="#id248394">Setting the <code class="varname">disable</code> parameter</a></dt><dt>1.2. <a href="#id248437">Setting the <code class="varname">mediaproxy_socket</code> parameter</a></dt><dt>1.3. <a href="#id293418">Setting the <code class="varname">mediaproxy_timeout</code> parameter</a></dt><dt>1.4. <a href="#id248318">Setting the <code class="varname">signaling_ip_avp</code> parameter</a></dt><dt>1.5. <a href="#id248360">Setting the <code class="varname">media_relay_avp</code> parameter</a></dt><dt>1.6. <a href="#id293612">Setting the <code class="varname">ice_candidate</code> parameter</a></dt><dt>1.7. <a href="#id293653">Setting the <code class="varname">ice_candidate_avp</code> parameter</a></dt><dt>1.8. <a href="#id293708">Using the <code class="function">engage_media_proxy</code> function</a></dt><dt>1.9. <a href="#id293776">Using the <code class="function">use_media_proxy</code> function</a></dt><dt>1.10. <a href="#id293818">Using the <code class="function">end_media_session</code> function</a></dt></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id282001"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id270469"></a>1.1. Overview</h2></div></div></div><p>
      Mediaproxy is an OpenSIPS module that is designed to allow automatic 
      NAT traversal for the majority of existing SIP clients. This means 
      that there will be no need to configure anything in particular on 
      the NAT box to allow these clients to work behind NAT when using 
      the mediaproxy module.
    </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id274256"></a>1.2. Principle of operation</h2></div></div></div><p>
      This NAT traversal solution operates by placing a media relay in the
      middle between 2 SIP user-agents. It mangles the SDP messages for both
      of them in a way that will make the parties talk with the relay while
      they think they talk directly with each other.
    </p><p>
      Mediaproxy consists of 2 components:
      </p><div class="itemizedlist"><ul type="disc"><li><p>The OpenSIPS mediaproxy module</p></li><li><p>
            An external application called MediaProxy which employs a
            dispatcher and multiple distributed media relays. This is
            available from http://ag-projects.com/MediaProxy.html
            (version 2.0.0 or newer is required by this module).
          </p></li></ul></div><p>
    </p><p>
      The mediaproxy dispatcher runs on the same machine as OpenSIPS
      and its purpose is to select a media relay for a call. The media
      relay may run on the same machine as the dispatcher or on multiple
      remote hosts and its purpose is to forward the streams between the
      calling parties. To find out more about the architecture of MediaProxy
      please read the documentation that comes with it.
    </p><p>
      To be able to act as a relay between the 2 user agents, the machine(s)
      running the module/proxy server must have a public IP address.
    </p><p>
      OpenSIPS will ask the media relay to allocate as many ports as there are
      media streams in the SDP offer and answer. The media relay will send back
      to OpenSIPS the IP address and port(s) for them. Then OpenSIPS will
      replace the original contact IP and RTP ports from the SDP messages with
      the ones provided by the media relay. By doing this, both user agents will
      try to contact the media relay instead of communicating directly with each
      other. Once the user agents contact the media relay, it will record the
      addresses they came from and will know where to forward packets received
      from the other endpoint. This is needed because the address/port the NAT
      box will allocate for the media streams is not known before they actually
      leave the NAT box. However the address of the media relay is always known
      (being a public IP) so the 2 endpoints know where to connect. After they
      do so, the relay learns their addresses and can forward packets between
      them.
    </p><p>
      The SIP clients that will work transparently behind NAT when using
      mediaproxy, are the so-called symmetric clients. The symmetric clients
      have the particularity that use the same port to send and receive data.
      This must be true for both signaling and media for a client to work
      transparently with mediaproxy without any configuration on the NAT box.
    </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id276604"></a>1.3. Features</h2></div></div></div><p>
      </p><div class="itemizedlist"><ul type="disc"><li><p>
            make symmetric clients work behind NAT transparently, with no
            configuration needed on the client's NAT box.
          </p></li><li><p>
            have the ability to distribute RTP traffic on multiple media relays
            running on multiple hosts.
          </p></li></ul></div><p>
    </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249300"></a>1.4. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249582"></a>1.4.1. OpenSIPS Modules</h3></div></div></div><p>
        The following modules must be loaded before this module:
        </p><div class="itemizedlist"><ul type="disc"><li><p>
              <span class="emphasis"><em>dialog</em></span> module - if engage_media_proxy is used
              (see below the description of engage_media_proxy).
            </p></li></ul></div><p>
      </p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249607"></a>1.4.2. External Libraries or Applications</h3></div></div></div><p>
        The following libraries or applications must be installed before
        running OpenSIPS with this module loaded:
        </p><div class="itemizedlist"><ul type="disc"><li><p>
              <span class="emphasis"><em>None</em></span>.
            </p></li></ul></div><p>
      </p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249632"></a>1.5. Exported parameters</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249638"></a>1.5.1. <code class="varname">disable</code> (int)</h3></div></div></div><p>
        Boolean flag that specifies if mediaproxy should be disabled. This
        is useful when you want to use the same OpenSIPS configuration in
        two different context, one using mediaproxy, the other not. In the
        case mediaproxy is disabled, calls to its functions will have no
        effect, allowing you to use the same configuration without changes.
      </p><p>
        <span class="emphasis"><em>
          Default value is &#8220;<span class="quote">0</span>&#8221;.
        </em></span>
      </p><div class="example"><a name="id248394"></a><p class="title"><b>Example 1.1. Setting the <code class="varname">disable</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mediaproxy", "disable", 1)
...
        </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248414"></a>1.5.2. <code class="varname">mediaproxy_socket</code> (string)</h3></div></div></div><p>
        It is the path to the filesystem socket where the mediaproxy dispatcher
        listens for commands from the module.
      </p><p>
        <span class="emphasis"><em>
          Default value is 
            &#8220;<span class="quote">/var/run/mediaproxy/dispatcher.sock</span>&#8221;.
        </em></span>
      </p><div class="example"><a name="id248437"></a><p class="title"><b>Example 1.2. Setting the <code class="varname">mediaproxy_socket</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mediaproxy", "mediaproxy_socket", "/var/run/mediaproxy/dispatcher.sock")
...
        </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248453"></a>1.5.3. <code class="varname">mediaproxy_timeout</code> (int)</h3></div></div></div><p>
        How much time (in milliseconds) to wait for an answer from the
        mediaproxy dispatcher.
      </p><p>
        <span class="emphasis"><em>
          Default value is &#8220;<span class="quote">500</span>&#8221;.
        </em></span>
      </p><div class="example"><a name="id293418"></a><p class="title"><b>Example 1.3. Setting the <code class="varname">mediaproxy_timeout</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mediaproxy", "mediaproxy_timeout", 500)
...
        </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293433"></a>1.5.4. <code class="varname">signaling_ip_avp</code> (string)</h3></div></div></div><p>
        Specification of the AVP which holds the IP address from where
        the SIP signaling originated. If this AVP is set it will be used
        to get the signaling IP address, else the source IP address
        from where the SIP message was received will be used.
        This AVP is meant to be used in cases where there are more than
        one proxy in the call setup path and the proxy that actually
        starts mediaproxy doesn't receive the SIP messages directly
        from the UA and it cannot determine the NAT IP address from
        where the signaling originated. In such a case attaching a
        SIP header at the first proxy and then copying that header's
        value into the signaling_ip_avp on the proxy that starts
        mediaproxy will allow it to get the correct NAT IP address
        from where the SIP signaling originated.
      </p><p>
        <span class="emphasis"><em>
          Default value is &#8220;<span class="quote">$avp(signaling_ip)</span>&#8221;.
        </em></span>
      </p><div class="example"><a name="id248318"></a><p class="title"><b>Example 1.4. Setting the <code class="varname">signaling_ip_avp</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mediaproxy", "signaling_ip_avp", "$avp(nat_ip)")
...
        </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248335"></a>1.5.5. <code class="varname">media_relay_avp</code> (string)</h3></div></div></div><p>
        Specification of the AVP which holds an optional application
        defined media relay IP address of a particular media relay that
        is preferred to be used for the current call. If an IP address
        is written to this AVP before calling use_media_proxy(), it
        will be preferred by the dispatcher over the normal selection
        algorithm.
      </p><p>
        <span class="emphasis"><em>
          Default value is &#8220;<span class="quote">$avp(media_relay)</span>&#8221;.
        </em></span>
      </p><div class="example"><a name="id248360"></a><p class="title"><b>Example 1.5. Setting the <code class="varname">media_relay_avp</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mediaproxy", "media_relay_avp", "$avp(media_relay)")
...
        </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293588"></a>1.5.6. <code class="varname">ice_candidate</code> (string)</h3></div></div></div><p>
        Indicates the type of ICE candidate that will be added to the SDP. 
        It can take 3 values: 'none', 'low-priority' or 'high-priority'. 
        If 'none' is selected no candidate will be adeed to the SDP. If 
        'low-priority' is selected then a low priority candidate will be 
        added and if 'high-priority' is selected a high priority one.
      </p><p>
        <span class="emphasis"><em>
          Default value is &#8220;<span class="quote">none</span>&#8221;.
        </em></span>
      </p><div class="example"><a name="id293612"></a><p class="title"><b>Example 1.6. Setting the <code class="varname">ice_candidate</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mediaproxy", "ice_candidate", "low-priority")
...
        </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293629"></a>1.5.7. <code class="varname">ice_candidate_avp</code> (string)</h3></div></div></div><p>
        Specification of the AVP which holds the ICE candidate that will be 
        inserted in the SDP. The value specified in this AVP will override 
        the value in ice_candidate module parameter.

        Note that if use_media_proxy() and end_media_session() functions are
        being used, the AVP will not be available in the reply route unless 
        you set onreply_avp_mode from the tm module to '1', and if the AVP 
        is not set, the default value will be used.
      </p><p>
        <span class="emphasis"><em>
          Default value is &#8220;<span class="quote">$avp(ice_candidate)</span>&#8221;.
        </em></span>
      </p><div class="example"><a name="id293653"></a><p class="title"><b>Example 1.7. Setting the <code class="varname">ice_candidate_avp</code> parameter</b></p><div class="example-contents"><pre class="programlisting">
...
modparam("mediaproxy", "ice_candidate_avp", "$avp(ice_candidate)")
...
        </pre></div></div><br class="example-break"></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293671"></a>1.6. Exported Functions</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293676"></a>1.6.1. <code class="function">engage_media_proxy()</code></h3></div></div></div><p>
        Trigger the use of MediaProxy for all the dialog requests and
        replies that have an SDP body. This needs to be called only
        once for the first INVITE in a dialog. After that it will use
        the dialog module to trace the dialog and automatically call
        use_media_proxy() on every request and reply that belongs to
        the dialog and has an SDP body. When the dialog ends it will
        also call automatically end_media_session(). All of these are
        called internally on dialog callbacks, so for this function to
        work, the dialog module must be loaded and configured.
      </p><p>
        This function is an advanced mechanism to use a media relay
        without having to manually call a function on each message that
        belongs to the dialog. However this method is less flexible,
        because once things were set in motion by calling this function
        on the first INVITE, it cannot be stopped, not even by calling
        end_media_session(). It will only stop when the dialog ends.
        Until then it will modify the SDP content of every in-dialog
        message to make it use a media relay. If one needs more control
        over the process, like starting to use mediaproxy only later in
        the failure route, or stopping to use mediaproxy in the failure
        route, then the use_media_proxy and end_media_session functions
        should be used, and manually called as appropriate. Using this
        function should NOT be mixed with either of use_media_proxy()
        or end_media_session().
      </p><p>
        This function can be used from REQUEST_ROUTE.
      </p><div class="example"><a name="id293708"></a><p class="title"><b>Example 1.8. Using the <code class="function">engage_media_proxy</code> function</b></p><div class="example-contents"><pre class="programlisting">
...
if (method==INVITE &amp;&amp; !has_totag()) {
    # We can also use a specific media relay if we need to
    #$avp(media_relay) = "1.2.3.4";
    engage_media_proxy();
}
...
        </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293729"></a>1.6.2. <code class="function">use_media_proxy()</code></h3></div></div></div><p>
        Will make a call to the dispatcher and replace the IPs and ports
        in the SDP body with the ones returned by the media relay for
        each supported media stream in the SDP body. This will force the
        media streams to be routed through the media relay. If a mix of
        supported and unsupported streams are present in the SDP, only
        the supported streams will be modified, while the unsupported
        streams will be left alone.
      </p><p>
        This function should NOT be mixed with engage_media_proxy().
      </p><p>This function has the following return codes:</p><p>
        </p><div class="itemizedlist"><ul type="disc"><li><p>
          +1 - successfully modified message (true value)
        </p></li><li><p>
          -1 - error in processing message (false value)
        </p></li><li><p>
          -2 - missing SDP body, nothing to process (false value)
        </p></li></ul></div><p>
      </p><p>
        This function can be used from REQUEST_ROUTE, ONREPLY_ROUTE, FAILURE_ROUTE, BRANCH_ROUTE.
      </p><div class="example"><a name="id293776"></a><p class="title"><b>Example 1.9. Using the <code class="function">use_media_proxy</code> function</b></p><div class="example-contents"><pre class="programlisting">
...
if (method==INVITE) {
    # We can also use a specific media relay if we need to
    #$avp(media_relay) = "1.2.3.4";
    use_media_proxy();
}
...
        </pre></div></div><br class="example-break"></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293796"></a>1.6.3. <code class="function">end_media_session()</code></h3></div></div></div><p>
        Will call on the dispatcher to inform the media relay to end the
        media session. This is done when a call ends, to instruct the media
        relay to release the resources allocated to that call as well as
        to save logging information about the media session. Called on BYE,
        CANCEL or failures.
      </p><p>
        This function should NOT be mixed with engage_media_proxy().
      </p><p>
        This function can be used from REQUEST_ROUTE, ONREPLY_ROUTE, FAILURE_ROUTE, BRANCH_ROUTE.
      </p><div class="example"><a name="id293818"></a><p class="title"><b>Example 1.10. Using the <code class="function">end_media_session</code> function</b></p><div class="example-contents"><pre class="programlisting">
...
if (method==BYE) {
    end_media_session();
}
...
        </pre></div></div><br class="example-break"></div></div></div></div></body></html>
