<html><head><meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1"><title>Perl Virtual Database Module</title><link rel="stylesheet" href="/html/css/module-docbook.css" type="text/css"><meta name="generator" content="DocBook XSL Stylesheets V1.73.2"></head><body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF"><div class="book" lang="en"><div class="titlepage"><div><div><h1 class="title"><a name="id284028"></a>Perl Virtual Database Module</h1></div><div><div class="authorgroup"><div class="author"><h3 class="author"><span class="firstname">Bastian</span> <span class="surname">Friedrich</span></h3><div class="affiliation"><span class="orgname">Collax GmbH<br></span></div></div><div class="editor"><h4 class="editedby">Edited by</h4><h3 class="editor"><span class="firstname">Bastian</span> <span class="surname">Friedrich</span></h3></div></div></div><div><p class="copyright">Copyright © 2007 Collax GmbH</p></div><div><div class="revhistory"><table border="1" width="100%" summary="Revision history"><tr><th align="left" valign="top" colspan="2"><b>Revision History</b></th></tr><tr><td align="left">Revision $Revision: 5901 $</td><td align="left">$Date: 2009-07-21 09:45:05 +0200 (Tue, 21 Jul 2009) $</td></tr></table></div></div></div><hr></div><div class="toc"><p><b>Table of Contents</b></p><dl><dt><span class="chapter"><a href="#id249002">1. Admin Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id249005">1.1. Overview</a></span></dt><dt><span class="section"><a href="#id248031">1.2. Dependencies</a></span></dt><dd><dl><dt><span class="section"><a href="#id249265">1.2.1. OpenSIPS Modules</a></span></dt><dt><span class="section"><a href="#id249287">1.2.2. External Libraries or Applications</a></span></dt></dl></dd><dt><span class="section"><a href="#id248344">1.3. Exported Parameters</a></span></dt><dt><span class="section"><a href="#id248358">1.4. Exported Functions</a></span></dt></dl></dd><dt><span class="chapter"><a href="#id248999">2. Developer Guide</a></span></dt><dd><dl><dt><span class="section"><a href="#id248988">2.1. Introduction</a></span></dt><dt><span class="section"><a href="#id248406">2.2. Base class OpenSIPS::VDB</a></span></dt><dt><span class="section"><a href="#id248448">2.3. Data types</a></span></dt><dd><dl><dt><span class="section"><a href="#id248458">2.3.1. OpenSIPS::VDB::Value</a></span></dt><dt><span class="section"><a href="#id293561">2.3.2. OpenSIPS::VDB::Pair</a></span></dt><dt><span class="section"><a href="#id293578">2.3.3. OpenSIPS::VDB::ReqCond</a></span></dt><dt><span class="section"><a href="#id293595">2.3.4. OpenSIPS::VDB::Column</a></span></dt><dt><span class="section"><a href="#id293613">2.3.5. OpenSIPS::VDB::Result</a></span></dt></dl></dd><dt><span class="section"><a href="#id293624">2.4. Adapters</a></span></dt><dd><dl><dt><span class="section"><a href="#id293641">2.4.1. Function parameters</a></span></dt></dl></dd><dt><span class="section"><a href="#id293691">2.5. VTabs</a></span></dt></dl></dd></dl></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id249002"></a>Chapter 1. Admin Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id249005"></a>1.1. Overview</h2></div></div></div><p>
		The Perl Virtual Database (VDB) provides a virtualization framework
		for OpenSIPS's database access. It does not handle a particular
		database engine itself but lets the user relay database requests
		to arbitrary Perl functions.
	</p><p>
		This module cannot be used "out of the box". The user has to supply
		functionality dedicated to the client module. See below for options.
	</p><p>
		The module can be used in all current OpenSIPS modules that need
		database access. Relaying of insert, update, query and delete
		operations is supported.
	</p><p>
		Modules can be configured to use the perlvdb module as
		database backend using the db_url_parameter:
	</p><pre class="programlisting">
modparam("acc", "db_url", "perlvdb:OpenSIPS::VDB::Adapter::AccountingSIPtrace")
</pre><p>
		This configuration options tells acc module that it should use the
		perlvdb module which will in turn use the Perl class
		OpenSIPS::VDB::Adapter::AccountingSIPtrace
		to relay the database requests.
	</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248031"></a>1.2. Dependencies</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249265"></a>1.2.1. OpenSIPS Modules</h3></div></div></div><p>
		The following  modules must be loaded before this module:
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>perl</em></span> -- Perl module</p></li></ul></div><p>
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id249287"></a>1.2.2. External Libraries or Applications</h3></div></div></div><p>
		The following libraries or applications must be installed before running
		OpenSIPS with this module loaded:
			</p><div class="itemizedlist"><ul type="disc"><li><p>
				<span class="emphasis"><em>None</em></span> (Besides the ones mentioned in the perl
				module documentation).
			</p></li></ul></div><p>
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248344"></a>1.3. Exported Parameters</h2></div></div></div><p>
			<span class="emphasis"><em>None</em></span>.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248358"></a>1.4. Exported Functions</h2></div></div></div><p>
			<span class="emphasis"><em>None</em></span>.
		</p></div></div><div class="chapter" lang="en"><div class="titlepage"><div><div><h2 class="title"><a name="id248999"></a>Chapter 2. Developer Guide</h2></div></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248988"></a>2.1. Introduction</h2></div></div></div><p>
		OpenSIPS uses a database API for requests of numerous different
		types of data. Four primary operations are supported:
			</p><div class="itemizedlist"><ul type="disc"><li><p>query</p></li><li><p>insert</p></li><li><p>update</p></li><li><p>delete</p></li></ul></div><p>
		</p><p>
			This module relays these database requests to user implemented
			Perl functions.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248406"></a>2.2. Base class OpenSIPS::VDB</h2></div></div></div><p>
			A client module has to be configured to use the perlvdb module in conjunction
			with a Perl class to provide the functions. The configured class needs to
			inherit from the base class <code class="literal">OpenSIPS::VDB</code>.
		</p><p>
			Derived classes have to implement the necessary
			functions "query", "insert", "update" and/or "delete". The client module
			specifies the necessary functions.
			To find out which functions are called from a module, its processes may
			be evaluated with the <code class="literal">OpenSIPS::VDB::Adapter::Describe</code> class which will
			log incoming requests (without actually providing any real functionality).
		</p><p>
			While users can directly implement their desired functionality in a class
			derived from OpenSIPS::VDB, it is advisable to split the implementation into
			an Adapter that transforms the relational structured parameters into pure
			Perl function arguments, and add a virtual table (VTab) to provide the
			relaying to an underlying technology.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id248448"></a>2.3. Data types</h2></div></div></div><p>
			Before introducing the higher level concepts of this module, the used
			datatypes will briefly be explained.
			The OpenSIPS Perl library includes some data types that have to be used
			in this module:
		</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id248458"></a>2.3.1. OpenSIPS::VDB::Value</h3></div></div></div><p>
			A value includes a data type flag and a value. Valid data types are
			DB_INT, DB_DOUBLE, DB_STRING, DB_STR, DB_DATETIME, DB_BLOB, DB_BITMAP.
			A new variable may be created with </p><pre class="programlisting">
my $val = new OpenSIPS::VDB::Value(DB_STRING, "foobar");
</pre><p>
			Value objects contain the type() and data() methods to get or set the type
			and data attributes.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293561"></a>2.3.2. OpenSIPS::VDB::Pair</h3></div></div></div><p>
			The Pair class is derived from the Value class and additionally contains a
			column name (key).
			A new variable may be created with </p><pre class="programlisting">
my $pair = new OpenSIPS::VDB::Pair("foo", DB_STRING, "bar");
</pre><p>
			where foo is the key and bar is the value.
			Additonally to the methods of the Value class, it contains a key() method to
			get or set the key attribute.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293578"></a>2.3.3. OpenSIPS::VDB::ReqCond</h3></div></div></div><p>
			The ReqCond class is used for select condition and is derived from the Pair
			class. It contains an addtional operator attribute.
			A new variable may be created with </p><pre class="programlisting">
my $cond = new OpenSIPS::VDB::ReqCond("foo", "&gt;", DB_INT, 5);
</pre><p>
			where foo is the key, "greater" is the operator and 5 is the value to compare.
			Additonally to the methods of the Pair class, it contains an op() method to
			get or set the operator attribute.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293595"></a>2.3.4. OpenSIPS::VDB::Column</h3></div></div></div><p>
			This class represents a column definition or database schema. It contains an
			array for the column names and an array for the column types. Both arrays need
			to have the same length.
			A new variable may be created with </p><pre class="programlisting">
my @types = { DB_INT, DB_STRING };
my @names = { "id", "vals" };
my $cols = new OpenSIPS::VDB::Column(\@types, \@names);
</pre><p>
			The class contains the methods type() and name() to get or set the type and name
			arrays.
		</p></div><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293613"></a>2.3.5. OpenSIPS::VDB::Result</h3></div></div></div><p>
			The Result class represents a query result. It contains a schema (class Column)
			and an array of rows, where each row is an array of Values. The object methods
			coldefs() and rows() may be used to get and set the object attributes.
		</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293624"></a>2.4. Adapters</h2></div></div></div><p>
			Adapters should be used to turn the relational structured database request into
			pure Perl function arguments. The alias_db function alias_db_lookup for example 
			takes a user/host pair, and turns it into another user/host pair. The Alias
			adapter turns the ReqCond array into two separate scalars that are used as parameters
			for a VTab call.
		</p><p>
			Adapter classes have to inherit from the OpenSIPS::VDB base class and may provide
			one or more functions with the names insert, update, replace, query and/or delete,
			depending on the module which is to be used with the adapter. While modules such as
			alias_db only require a query function, others -- such as siptrace -- depend
			on inserts only.
		</p><div class="section" lang="en"><div class="titlepage"><div><div><h3 class="title"><a name="id293641"></a>2.4.1. Function parameters</h3></div></div></div><p>
				The implemented functions need to deal with the correct data types. The
				parameter and return types are listed in this section.
			</p><p>
				<span class="emphasis"><em>insert()</em></span> is passed an array of OpenSIPS::VDB::Pair objects.
				It should return an integer value.
			</p><p>
				<span class="emphasis"><em>replace()</em></span> is passed an array of OpenSIPS::VDB::Pair objects.
				This function is currently not used by any publicly available modules.
				It should return an integer value.
			</p><p>
				<span class="emphasis"><em>delete()</em></span> is passed an array of OpenSIPS::VDB::ReqCond objects.
				It should return an integer value.
			</p><p>
				<span class="emphasis"><em>update()</em></span> is passed an array of OpenSIPS::VDB::ReqCond objects
				(which rows to update) and an array of OpenSIPS::VDB::Pair objects
				(new data).
				It should return an integer value.
			</p><p>
				<span class="emphasis"><em>query()</em></span> is passed an array of OpenSIPS::VDB::ReqCond objects
				(which rows to select), an array of strings (which column names to return)
				and a single string by which column to sort.
				It should return an object of type OpenSIPS::VDB::Result.
			</p></div></div><div class="section" lang="en"><div class="titlepage"><div><div><h2 class="title" style="clear: both"><a name="id293691"></a>2.5. VTabs</h2></div></div></div><p>
			VTabs (virtual tables) provide a particular implementation for an adapter. The Alias
			adapter e.g. calls a function with two parameters (user, host) and expects a hash to
			be returned with the two elements username and domain, or undef (when no result
			is found).
			A sample VTab implementation for the Alias adapter demonstrates this technique with
			a Perl hash that contains the alias data.
		</p><p>
			The standard Adapter/VTab pattern lets the user choose between three options on how to
			implement VTabs:
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>Single function</em></span>. When a function is used
				as a virtual table, it is passed the operation name (insert, replace, update,
				query, delete) as its first parameter. The function may be implemented
				in the main namespace.</p></li></ul></div><p>
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>Package/class</em></span>. The defined class needs
				to have an init() function. It will be called during the first call of that
				VTab.
				Addtionally, the package has
				to define the necessary functions insert, replace, update, delete and/or query.
				These functions will be called in a function context (first parameter is the
				class name).
				</p></li></ul></div><p>
			</p><div class="itemizedlist"><ul type="disc"><li><p><span class="emphasis"><em>Object</em></span>. The defined class needs
				to have a new() function which will return a reference to the newly
				created object. This object needs to define the necessary functions insert,
				replace, update, delete and/or query.
				These functions will be called in a method context (first parameter is
				a reference to the object).
				</p></li></ul></div><p>
		</p></div></div></div></body></html>
